
footprint
=========

# Abstract

_footprint_, the mobile app, is a utility app designed for creating
and uploading geocached media messages. (Geocaching meets Instagram?) A message
can be in plain text, audio, photo or video format.

Upon creating a message, a user can choose:

1. **permitted users (scope)**, where the message can be marked for a specific
friend, group of friends, all followers, public, or other (emails not necessarily of
friends in the system)
2. **discoverable-only or auto-publish**, discoverable-only meaning
one would have to unlock the message by being near it, auto-publish
being the message is automatically available to be viewed from any location
3. **active or passive**, where the message is broadcasted for permitted
users to know of (sends push notification to target friend?) or kept
completely private (and hence, serendipitous?)

In addition to creating messages, a user can consume messages that
they've uncovered or are public. Alternate ways of processing this
data include:

1. **push notifications**, exclaiming that a message has been
uncovered based on location
2. **map explore view**, a local map view that shows messages (locked
and unlocked) along with avatars
3. **activity feed / inbox**, where activity such as messages that
have been broadcast to the user or that have been recently unlocked by
the user
4. **public messages feed**, where user can access public messages
based on location, rating, category, etc.

# Remaining questions

Can messages be grouped or ordered? ie. play-by-play scavenger hunt scenario?
or play-by-play tour?


# User Relationships


1. One to One
2. One to Many (friends)
3. One to Public (all)
4. Many to One
5. Many to Many (friends)
6. Many to Public (harlem shake?)
7. (8&9) Public to * (**these don't make sense**)

***

# Friend to close friend (significant other?)

- As an urban adventurer
- I want to leave private messages for my significant other
- So that we can share a memory together

- As a person who likes to travel alone
- I want an unobtrusive way to share travel experiences with friends
- So that we can build intimacy from exclusivity (inside jokes?) in our
- friendships.

## Scenario 1: Leaving a friend only, uncoverable, passive message

- Given that I am traveling in Thailand this week
- And my good friend MT is traveling in Thailand next week
- And my good friend MT loves pad thai
- When I find a good pad thai spot in Thailand
- Then I can leave a hidden message for her "Gotta have the #4 shrimp w/ peanut sauce"
- And if she ever stumbles upon it geolocationally(?) she sees a very
- serendipitous message.

## Scenario 2: Leaving a friend only, uncoverable, active message

- ...
- Then I can leave a message for her to "You gotta try the #4 shrimp w/
- peanut sauce!"
- And she will see it on her activity feed? push notification? inbox?
- And she can seek it out to geo-uncover the message!


## Scenario 3: Leaving a friend only public message

- ...
- Then I can leave a public message "I loved the #4 shrimp w/ peanut sauce."
- And she can see the message (geotagged to map) immediately

***

# Friend to many friends

- As a traveler travelling with or without friends
- And friends travelling afterwards
- I want to be able to leave messages (gems) for them to
  serendiptously find
- So that I can share the climing experience
- And we can continue the conversation of that shared experience
(other wise I would never know we crossed paths, right?)

- As a rock climber deep water soloing in Thailand this week
- And some rock climbing friends will be deep water soloing in
  Thailand next week
- When I find a good route on a boulder

***

# Many friends to friend/many friends?

***

# Professional to Public

***

# 


facebook integration
====================
# on windows:

D:\Michael\www\footprint\android\assets>keytool -exportcert -alias androiddebugk
ey -keystore D:\Michael\.android\debug.keystore |c:\cygwin\bin\openssl sha1 -bin
ary | c:\cygwin\bin\openssl base64
Enter keystore password:  android
P7OGnSPz/jqJpW01UT6eJIq+tBw=

